import java.net.*;
import java.io.*;
import java.util.*;

public class Client {
  
  private OutputStreamWriter out;
  private Socket connection;
  private String userName;
    
  /**
   * initializes an output stream to the client
   * @param connection A socket to for the client
   */
  public Client(Socket connection) {
    
    //Temporary client name generator
    Random r = new Random();
    userName = "";
    for (int i = 0; i < 4; i++) {
      userName += (char)(r.nextInt(26) + 97);
    }
    System.out.println(userName);
    this.connection = connection;
    if (connection == null)
      throw new IllegalArgumentException("connection is null");
    try {
      out = new OutputStreamWriter(connection.getOutputStream());
    } catch (IOException e) {
      System.err.println("could not get outputStream fron connection");
    }
  }
  
  /**
   * Sends a message to a client
   * @param message The message that is to be sent
   * @return true if the message was sent succesfully, false if it fails
   */
  public boolean sendMsg(String message) {
    try {
      out.write(message);
      out.flush();
    } catch (IOException e) {
      return false;
    }
    return true;
  }
  
  /**
   * Gets the user name of the client
   * @return the clients user name
   */
  public String getUserName() {
    return userName;
  }
}
