import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.net.*;
import java.io.*;
import javax.swing.table.*;
import java.beans.*;
import javax.swing.plaf.basic.BasicInternalFrameUI;

public class ClientInterface {
  
  JFrame frame;
  
  public ClientInterface() {
    // decorate window
    JFrame.setDefaultLookAndFeelDecorated(true);
    JDialog.setDefaultLookAndFeelDecorated(true);
    frame = new ClientInterfaceFrame();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.show();
  }
  
  public static void main(String[] args) {
    // network portion
    ClientInterface cl = new ClientInterface();
    try {
      Socket s = new Socket("128.208.1.208", 1024);  
      InputStream in = new BufferedInputStream(s.getInputStream());
      while(true) {
          System.out.println(in);
          String str = "";
          int c = in.read();
          System.out.println((char)c);
          while(c != 13) {
            str += (char)c;
            c = in.read();
            System.out.println((char)c);
          }
          System.out.println(str);
          if(str.equals("change")) {
            //cl.changeColor();
          }
          System.out.println(s);
      }
    } catch (Exception e) {
      System.err.println(e);
    }
  }
}

class ClientInterfaceFrame extends JFrame {
  private ClientInterfacePanel canvas;
  private JPanel topPanel1, topPanel2, buttonPanel, bottomPanel, rightPanel1, leftPanel1, rightPanel2, leftPanel2;
  private JMenuBar menuBar;
  private JMenuItem exit, help, about, _new; // menu items for main menu bar
  private JButton create, join, options, quit, _return;
  private JTable table;
  private JSlider sizeSlider; // slider to set size of brush

  final JInternalFrame iframe1 = new JInternalFrame("", false, false, false, false);
  final JInternalFrame iframe2 = new JInternalFrame("", false, false, false, false);
  
  private JDesktopPane desktop;

  private static final int WIDTH = 700;
  private static final int HEIGHT = 500;

  String user_name, room_title;

  public ClientInterfaceFrame() {
    user_name = JOptionPane.showInputDialog("Please Enter User Name");
    
    if (user_name == null || user_name.length() == 0) {
      System.exit(0);
    }
    
    setTitle("OpenSpace - [" + user_name + "]");
    setSize(WIDTH, HEIGHT);
    ((BasicInternalFrameUI)iframe1.getUI()).setNorthPane(null);
    ((BasicInternalFrameUI)iframe2.getUI()).setNorthPane(null);
    iframe1.setBorder(null);
    iframe2.setBorder(null);
    

    // setup menus
    // build menu bar
    menuBar = new JMenuBar();
    JMenu fileMenu = new JMenu("File");
    JMenu helpMenu = new JMenu("Help");
    menuBar.add(fileMenu);
    menuBar.add(helpMenu);

    // menu bar items
    _new = new JMenuItem("New");
    exit = new JMenuItem("Exit");
    help = new JMenuItem("Help");
    about = new JMenuItem("About");

    ButtonListener bListen = new ButtonListener();
    _new.addActionListener(bListen);
    exit.addActionListener(bListen);
    help.addActionListener(bListen);
    about.addActionListener(bListen);

    fileMenu.add(_new);
    fileMenu.add(exit);
    helpMenu.add(help);
    helpMenu.add(about);

    // ==============================================
    
    desktop = new JDesktopPane();
    setContentPane(desktop);
        setJMenuBar(menuBar);
    desktop.add(iframe1);
    desktop.add(iframe2);
    try {
      iframe1.setMaximum(true);
      iframe2.setMaximum(true);
    } catch(PropertyVetoException e){};

    iframe1.show();

    
    canvas = new ClientInterfacePanel();
    canvas.setBackground(Color.WHITE);

    buttonPanel = new JPanel();
    bottomPanel = new JPanel();
    rightPanel1 = new JPanel();
    leftPanel1 = new JPanel();
    rightPanel2 = new JPanel();
    leftPanel2 = new JPanel();
    topPanel1 = new JPanel(); 
    topPanel2 = new JPanel();
    
    String[] columnNames = {"No.", "Title", "Users", "Status"};
    Object[][] cells = new Object[10][4];
    table = new JTable(cells, columnNames);
    
    buttonPanel.setLayout(new GridLayout(1, 6));
    rightPanel1.setLayout(new GridLayout(4,1));
    

    
    //menuPanel.add(menuBar);

    // buttons to change color
    ButtonGroup group1 = new ButtonGroup();
    makeColorButton("Black", Color.BLACK, group1);
    makeColorButton("Red", Color.RED, group1);
    makeColorButton("Blue", Color.BLUE, group1);
    makeColorButton("Green", Color.GREEN, group1);
    makeColorButton("Yellow", Color.YELLOW, group1);
    makeColorButton("Erase", Color.WHITE, group1);
    
    // slider to change paint brush size
    sizeSlider = new JSlider(1, 20, 10);
    canvas.setSize(10);
    sizeSlider.addChangeListener(new ChangeListener() {
      public void stateChanged (ChangeEvent event) {
        canvas.setSize(sizeSlider.getValue());
      }
    });
    
    buttonPanel.add(sizeSlider);
    makeWaitroomButtons();
    makePlayroomButtons();
    makePanels();
  }
  
  public void makePanels() {
    iframe1.getContentPane().add(topPanel1, BorderLayout.NORTH);
    iframe1.getContentPane().add(new JScrollPane(table), BorderLayout.CENTER);
    iframe1.getContentPane().add(bottomPanel, BorderLayout.SOUTH);
    iframe1.getContentPane().add(leftPanel1, BorderLayout.WEST);
    iframe1.getContentPane().add(rightPanel1, BorderLayout.EAST);
    iframe2.getContentPane().add(topPanel2, BorderLayout.NORTH);
    iframe2.getContentPane().add(canvas, BorderLayout.CENTER);
    iframe2.getContentPane().add(buttonPanel, BorderLayout.SOUTH);
    iframe2.getContentPane().add(leftPanel2, BorderLayout.WEST);
    iframe2.getContentPane().add(rightPanel2, BorderLayout.EAST);
  }
  
  private void makePlayroomButtons() {
    _return = new JButton("Return to Waitroom");
    _return.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent event) {
        iframe2.hide();
        canvas.clearScreen();
        iframe1.show();
      }
    });
    
    rightPanel2.add(_return);
  }
  
  private void makeWaitroomButtons() {
    create = new JButton("Create");
    join = new JButton("Join");
    options = new JButton("Options");
    quit = new JButton("Quit");
    
    create.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent event) {
        room_title = JOptionPane.showInputDialog("Please Enter Room Title");
        if (room_title != null && room_title.length()  != 0) {
          iframe1.hide();
          iframe2.show();
        }
      }
    });
    
    join.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent event) {
        iframe1.hide();
        iframe2.show();
      }
    });
    
    options.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent event) {
        JOptionPane.showMessageDialog(null, "Not Available", "Options", JOptionPane.INFORMATION_MESSAGE);
      }
    });                       
    
    quit.addActionListener( new ActionListener() {
      public void actionPerformed(ActionEvent event) {
        System.exit(0);
      }
    });
    
    rightPanel1.add(create);
    rightPanel1.add(join);
    rightPanel1.add(options);
    rightPanel1.add(quit);
  }

  public class ButtonListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      JMenuItem source = (JMenuItem)(e.getSource());
      if (source == _new) {
        canvas.clearScreen();
      }
      // exit program
      else if (source == exit) {
        System.exit(0);
      }
      // show help
      else if (source == help) {
        JOptionPane.showMessageDialog(null, "Sorry, No Help Available", "Help on Using OpenSpace", JOptionPane.INFORMATION_MESSAGE);
      }
      // show info
      else if (source == about) {
        JOptionPane.showMessageDialog(null, "OpenSpace Beta", "About OpenSpace", JOptionPane.INFORMATION_MESSAGE);
      } 
    }
  }

  // make buttons
  private void makeColorButton(String label, final Color c, ButtonGroup group) {
    // select first button in group
    boolean selected = group.getButtonCount() == 0;
    JRadioButton button = new JRadioButton(label, selected);
    buttonPanel.add(button);
    group.add(button);
    button.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent event) {
        canvas.setColor(c);
      }
    });
  }
}







// where painting takes place
class ClientInterfacePanel extends JPanel {

  private int xClick;
  private int yClick;
  private Color penColor;
  private int penSize;
  private ArrayList pathBox = new ArrayList();
  private PathBucket temp;

  public ClientInterfacePanel() {
    addMouseListener(new MouseAdapter() {
      public void mousePressed(MouseEvent event) {
        Point p = event.getPoint();
        temp = new PathBucket(penColor, penSize);
        pathBox.add(temp);
        temp.add(p);
        repaint();
      }
    });

    addMouseMotionListener(new MouseMotionAdapter() {
      public void mouseDragged(MouseEvent event) {
        Point p = event.getPoint();
        temp.add(p);
        repaint();
      }
    });
  }

  public void paintComponent(Graphics g) {
    super.paintComponent(g);
    Graphics2D g2 = (Graphics2D)g;
    

    Iterator iter = pathBox.iterator();
    while(iter.hasNext()) {
      PathBucket pb = (PathBucket)iter.next();
      ArrayList lst = pb.getList();
      g2.setColor(pb.getColor());
      BasicStroke stroke = new BasicStroke((float)pb.getSize(), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND);
      g2.setStroke(stroke);
      if (lst.size() > 1) {
        for (int i=0; i<lst.size()-1; i++) {
          Point start = (Point)lst.get(i);
          Point end = (Point)lst.get(i+1);
          g2.drawLine((int)start.getX(), (int)start.getY(), (int)end.getX(), (int)end.getY());
        }
      }
    }
  }

  // change color of the pen
  public void setColor(Color c) {
    penColor = c;
  }

  // clear screen
  public void clearScreen() {
    pathBox = new ArrayList();
    repaint();
  }
  
  public void setSize(int s) {
    penSize = s;
  }

  // inner class
  public class PathBucket {
    ArrayList a;
    Color c;
    int size;

    public PathBucket(Color c, int size) {
      this.c = c;
      this.size = size;
      a = new ArrayList();
    }

    public void add(Object obj) {
      a.add(obj);
    }

    public ArrayList getList() {
      return a;
    }

    public Color getColor() {
      return c;
    }
    
    public int getSize() {
      return size;
    }
  }
}

