import java.net.*;
import java.io.*;

public class ScanIncomingConnections implements Runnable {
  
  private Server server;
  
  /**
   * Constructs a scanning object that waits for incoming connections
   * @param server the server that it will send clients back to
   */
  public ScanIncomingConnections(Server server) {
    this.server = server;
  }
  
  /**
   * Overrided run method that goes when this thread is started
   */
  public void run() {
    ServerSocket wait = null;
    try {
      wait = new ServerSocket(1500);
    } catch (IOException e) {
      System.err.println("That port is blocked");
    }
    while (true) {
      // wait for an incoming connection...
      
      Socket connection = null;
      try {
        connection = wait.accept();
      } catch (IOException e) {
        System.err.println("That port is blocked");
      }
      
      // notify and send back the client...
      Client c = new Client(connection);
      server.addNewClient(c);
    }
  }
}
